<?php
/**
*
* @package smf Extension - qrlogin
* @copyright (c) 2017 qrlogin - http://qrlogin.info
* @license http://opensource.org/licenses/gpl-2.0.php GNU General Public License v2
*
*/

function qrlogin_board_url()
{
    global $modSettings, $boardurl;
    return ($modSettings['qrlogin_del_http']) ? str_replace(array('http://', 'https://', 'www.'), array('', '', ''), $boardurl) : $boardurl;
}

function template_qrLogin()
{
	global $context, $settings, $options, $scripturl, $modSettings, $txt;

	echo '
		<div class="tborder login" style="width: ', (int)$modSettings['qrlogin_qrcode_size'] + 240, 'px">
			<div class="cat_bar">
				<h3 class="catbg">
					<span class="ie6_header floatleft"><img src="', $settings['theme_url'], '/qrlogin/QRlogin60.png" width="24" alt="" class="icon" />qrLogin</span>
				</h3>
			</div>
			<span class="upperframe"><span></span></span>
			<div class="roundframe"><br class="clear" />
				<dl>
					<div id="qrlogin_qrcode">
                        <a id="qrl_qrcode" href="http://qrlogin.info" target="_blank" style="float: right; margin: 0 1em 1em 1em"></a>
                        ', $txt['qrlogin_prompt'], '
                        <span id="qrlogin_dots"></span>
                    </div>
                    <p class="error" id="qrlogin_login_error" style="display: none">', $txt['qrlogin_error'], '</p>
				</dl>
			</div>
			<span class="lowerframe"><span></span></span>
		</div>';
	
	$goto_url = isset($_SESSION['login_url']) ? $_SESSION['login_url'] : $scripturl;
	
    echo '
<script> window.jQuery || document.write("<script src=\"https://code.jquery.com/jquery-1.12.4.js\">\x3C/script>") </script> 
<script src="', $settings['theme_url'], '/qrlogin/qrcode.js"></script>
<script type="text/javascript">
var qrlogin_sid = "', $context['session_id'], '=" + randomString(10);
function qrlogin_if_logged() { 
    if(document.getElementById("qrlogin_qrcode").style["display"] == "none")
        return;
    var d = document.getElementById("qrlogin_dots");
    d.innerHTML = (d.innerHTML.length > 10) ? "." : d.innerHTML + ".";
    jQuery.ajax({
        url: "./?action=qrlogin;qra=ajax",
        method: "POST",
        data: { qrlogin_sid: qrlogin_sid },
        success: function(data) {
            if(data) window.location = "', $goto_url, '";
            else setTimeout(qrlogin_if_logged, ', $modSettings['qrlogin_timeout']*1000, '); 
        },
        error: function(jqXHR, textStatus, errorThrown) {
            document.getElementById("qrlogin_login_error").innerHTML = errorThrown;
            qrlogin_stop_scan();
        },
    });
}
function qrlogin_stop_scan(){
    document.getElementById("qrlogin_qrcode").style["display"] = "none";
    document.getElementById("qrlogin_login_error").style["display"] = "";
}
function randomString(length) {
    var result = "";
    for (var i = length; i > 0; --i) result += Math.floor(Math.random() * 36).toString(36);
    return result;
}
jQuery(document).ready(function() {
    var qrl_qrcode = document.getElementById("qrl_qrcode");
    var qrl_text = "QRLOGIN\nL:V1\n', qrlogin_board_url(), '\n" + qrlogin_sid;
    new QRCode( qrl_qrcode, {
        text: qrl_text,
        width: ', $modSettings['qrlogin_qrcode_size'], ', height: ', $modSettings['qrlogin_qrcode_size'], ',
        colorDark: "', $modSettings['qrlogin_qrcode_fore_color'], '", colorLight: "', $modSettings['qrlogin_qrcode_back_color'], '",
        correctLevel: QRCode.CorrectLevel.M
    });
    qrl_qrcode.title = "', $txt['qrlogin_scan'], '";
    if ( /Android|webOS|iPhone|iPad|iPod|Opera Mini/i.test(navigator.userAgent) )
        qrl_qrcode.href = "qrlogin://" + qrl_text.replace(/\n/g, "%0A") + "qrlogin://', $goto_url, '";

  	setTimeout(qrlogin_if_logged, ', $modSettings['qrlogin_timeout']*1000, ');
	', ($modSettings['qrlogin_login_timeout']) ? 'setTimeout(function(){ qrlogin_stop_scan(); }, ' . $modSettings['qrlogin_login_timeout']*60000 . ');' : '', '
});
</script>';
}

function template_qrLogin_user()
{
	global $context, $settings, $options, $scripturl, $modSettings, $txt;

	echo '
	<div>
		<form id="creator">
			<div class="cat_bar">
				<h3 class="catbg">
					<span class="ie6_header floatleft">', $txt['qrlogin_account'], '</span>
				</h3>
			</div>
			<div class="windowbg2">
				<span class="topslice"><span></span></span>
				<div class="content">
                    <dl>
                        <dt>
                            <strong>', $txt['qrlogin_register'], ':</strong><br />
                            <span class="smalltext">', $txt['qrlogin_register_explain'], '</span><br/><br/>
                            <span class="smalltext" id="qrlogin_description"></span>
                        </dt>
                        <dd>
                            <a id="qrl_qrcode" href="http://qrlogin.info" target="_blank" style="float:left; padding: 0 1em 1em 0"></a>
                        </dd>
                        <dt>
                            <strong>', $txt['qrlogin_password'], ':</strong><br />
                            <span class="smalltext">', $txt['qrlogin_password_explain'], '</span>
                        </dt>
                        <dd>
                            <input type="password" id="cur_pass" value="" size="20" class="input_password" autocomplete="off" oninput="qrlogin_set_qrcode()"/>
                            <button type="button" class="button_submit" onclick="qrlogin_set_qrcode()">', $txt['qrlogin_show_qrcode'], '</button>
                        </dd>
                    </dl>
				</div>
				<span class="botslice"><span></span></span>
			</div>
		</form>
		<br />';
		
	if ($context['allow_admin']) echo '
		<form action="', $scripturl . '?action=qrlogin;qra=page;save', '" method="post" accept-charset="', $context['character_set'], '" name="creator" id="creator" enctype="multipart/form-data"">
			<div class="cat_bar">
				<h3 class="catbg">
					<span class="ie6_header floatleft">', $txt['qrlogin_settings'], '</span>
				</h3>
			</div>
			<div class="windowbg2">
				<span class="topslice"><span></span></span>
				<div class="content">
                    <dl>
						<dt>', $txt['qrlogin_del_http'], ':<br /><span class="smalltext">', $txt['qrlogin_del_http_explain'], '</span></dt>
						<dd>
							<input type="hidden" name="qrlogin_del_http" value="0" />
							<input type="checkbox" name="qrlogin_del_http" id="qrlogin_del_http" value="1"', !empty($modSettings['qrlogin_del_http']) ? ' checked="checked"' : '', ' class="input_check" />
						</dd>
						<dt>', $txt['qrlogin_qrcode_size'], ':<br /><span class="smalltext">', $txt['qrlogin_qrcode_size_explain'], '</span></dt>
						<dd><input type="text" name="qrlogin_qrcode_size" size="4" maxlength="3" value="', (int)$modSettings['qrlogin_qrcode_size'], '" class="input_text" /> ', $txt['qrlogin_px'], '</dd>
                        <dt>', $txt['qrlogin_qrcode_color'], ':<br /><span class="smalltext">', $txt['qrlogin_qrcode_color_explain'], '</span></dt>
						<dd>
                            <input type="text" name="qrlogin_qrcode_fore_color" value="', $modSettings['qrlogin_qrcode_fore_color'], '" size="8" maxlength="8" class="jscolor {hash:true, uppercase:false}" />
                            &nbsp;/&nbsp;
                            <input type="text" name="qrlogin_qrcode_back_color" value="', $modSettings['qrlogin_qrcode_back_color'], '" size="8" maxlength="8" class="jscolor {hash:true, uppercase:false}" />
						</dd>
                    </dl>
                    <hr />
                    <dl>
						<dt>', $txt['qrlogin_login_timeout'], ':<br /><span class="smalltext">', $txt['qrlogin_login_timeout_explain'], '</span></dt>
						<dd><input type="text" name="qrlogin_login_timeout" size="4" maxlength="2" value="', (int)$modSettings['qrlogin_login_timeout'], '" class="input_text" /> ', $txt['qrlogin_minuts'], '</dd>
						<dt>', $txt['qrlogin_timeout'], ':<br /><span class="smalltext">', $txt['qrlogin_timeout_explain'], '</span></dt>
						<dd><input type="text" name="qrlogin_timeout" size="4" maxlength="1" value="', (int)$modSettings['qrlogin_timeout'], '" class="input_text" /> ', $txt['qrlogin_seconds'], '</dd>
						<dt>', $txt['qrlogin_poll_lifetime'], ':<br /><span class="smalltext">', $txt['qrlogin_poll_lifetime_explain'], '</span></dt>
						<dd><input type="text" name="qrlogin_poll_lifetime" size="4" maxlength="3" value="', (int)$modSettings['qrlogin_poll_lifetime'], '" class="input_text" /> ', $txt['qrlogin_seconds'], '</dd>
						<dt>', $txt['qrlogin_post_timeout'], ':<br /><span class="smalltext">', $txt['qrlogin_post_timeout_explain'], '</span></dt>
						<dd><input type="text" name="qrlogin_post_timeout" size="4" maxlength="2" value="', (int)$modSettings['qrlogin_post_timeout'], '" class="input_text" /> ', $txt['qrlogin_seconds'], '</dd>
                    </dl>
                    <dl>
                        <button type="submit" class="button_submit floatright">', $txt['save'], '</button>
                    </dl>
				</div>
				<span class="botslice"><span></span></span>
			</div>
		</form>
		<br />';

	echo '
		<form id="creator">
			<div class="cat_bar">
				<h3 class="catbg">
					<span class="ie6_header floatleft">', $txt['qrlogin_about'], '</span>
				</h3>
			</div>
			<div class="windowbg2">
				<span class="topslice"><span></span></span>
				<div class="content">
                    <a style="float:left; margin: 1em" href="http://qrlogin.info" target="_blank">
                        <img src="', $settings['theme_url'], '/qrlogin/logo.svg" width="100" title="', $txt['qrlogin_go_site'], '">
                    </a>
                	', $txt['qrlogin_about_explain'], '
                	<a style="float:right" href="https://play.google.com/store/apps/details?id=com.qrlogin" target="_blank">
                		<img src="', $settings['theme_url'], '/qrlogin/google-button.svg" width="120" title="', $txt['qrlogin_go_google'], '">
                	</a>
                	<a style="float:right" href="https://itunes.apple.com/ua/app/qrlogin/id1240222885" target="_blank">
                		<img src="', $settings['theme_url'], '/qrlogin/apple-button.svg" width="120" title="', $txt['qrlogin_go_apple'], '">
                	</a>
                	<br/><br/>
				</div>
				<span class="botslice"><span></span></span>
			</div>
		</form>
	</div>
	<br class="clear" />';
		
	echo '
<script src="', $settings['theme_url'], '/qrlogin/jscolor.js"></script>
<script src="', $settings['theme_url'], '/qrlogin/qrcode.js"></script>
<script type="text/javascript">
function qrlogin_set_qrcode(){
    var cur_pass = document.getElementById("cur_pass").value;
    var qrl_text = "QRLOGIN\nNU:V1\n', qrlogin_board_url(), '\n/?action=qrlogin\n', $context['user']['username'], '\n" + cur_pass + "\n1";
    qrcode.makeCode(qrl_text);
    if( /Android|webOS|iPhone|iPad|iPod|Opera Mini/i.test(navigator.userAgent) )
        qrl_qrcode.href = "qrlogin://" + qrl_text.replace(/\n/g, "%0A");
    qrl_qrcode.title = "', $txt['qrlogin_scan'], '";
    document.getElementById("qrlogin_description").innerHTML = (cur_pass == "") ? "', $txt['qrlogin_scan_description'], '" : "', $txt['qrlogin_scan_description_pass'], '";
}

var qrl_qrcode = document.getElementById("qrl_qrcode");
var qrcode = new QRCode( qrl_qrcode, {
        width: ', $modSettings['qrlogin_qrcode_size'], ', height: ', $modSettings['qrlogin_qrcode_size'], ',
        colorDark: "', $modSettings['qrlogin_qrcode_fore_color'], '", colorLight: "', $modSettings['qrlogin_qrcode_back_color'], '",
        correctLevel: QRCode.CorrectLevel.M
    });
qrlogin_set_qrcode();
</script>
';
		
}

?>